var CounGetRezult;
var IdCommand;
var UrlServer;
var Password;
var User;
var self;
var ord;
var timeout_term;
var glSelf;

odoo.define('pos_button.return_payment_by_payment_card_kkm', function(require) {
'use strict';
  const { Gui } = require('point_of_sale.Gui');
  const PosComponent = require('point_of_sale.PosComponent');
  const { identifyError } = require('point_of_sale.utils');
  const ProductScreen = require('point_of_sale.ProductScreen');
  const { useListener } = require("@web/core/utils/hooks");
  const Registries = require('point_of_sale.Registries');
  const PaymentScreen = require('point_of_sale.PaymentScreen');
  const Chrome = require('point_of_sale.Chrome');

   const KKM_Return_Payment_By_Payment_Card = (PaymentScreen) =>
       class extends PaymentScreen {

           KKM_Return_Payment_By_Payment_Card_click() {
                self = this;
                glSelf = this;
                console.log('KKM_Return_Payment_By_Payment_Card_click');
                LogJS('info','KKM_Return_Payment_By_Payment_Card_click')
                UrlServer = this.env.pos.config.UrlServer;
                if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
                User = this.env.pos.config.User;
                Password = this.env.pos.config.Password;
                var NumDevice = this.env.pos.config.NumDevice_term;
                var InnKkm = "";
                if (this.env.pos.config.InnKkm_term!=undefined && this.env.pos.config.InnKkm_term!=false){
                    InnKkm=this.env.pos.config.InnKkm_term
                }
                timeout_term = this.env.pos.config.timeout_term;
                if (timeout_term<1){
                    timeout_term=1
                }
                var order = this.env.pos.get_order();
                ord = order;
                var paymentlines = order.get_paymentlines();
                var Amount = 0;
                for (var i = 0; i < paymentlines.length; i++) {
                    if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
                };
                if (Amount==0){
                    alert('Не указана сумма для возврата по безналичному расчету');
                    return;
                }
                var quantities = _.map(order.get_orderlines(), function (line) {return line.quantity; });
                var plus=0;
                var minus = 0;
                var type=0;
                for (var i = 0; i < quantities.length; i++) {
                        if (quantities[i]>0){plus=plus+1;}
                        if (quantities[i]<0){minus=minus+1;}
                        if (plus>0 && minus==0){type=0;}
                        if (plus==0 && minus>0){type=1;}
                        if (plus>0 && minus>0){type=99;}
                    }
                if (type!=1){
                    alert('Сумма платежей должна быть отрицательной!')
                    return;
                }
                if (order.orderlines.length && order.orderlines[0].refunded_orderline_id) {
                    //alert(this.env.pos.toRefundLines)
                    var refundDetail = this.env.pos.toRefundLines[order.orderlines[0].refunded_orderline_id];
                    var refund_id = refundDetail.orderline.orderBackendId
                    this.env.services.rpc({
                        route: '/order/get_order_info',
                        params: {
                            order_id: refund_id,
                        },
                    }, { shadow: true }).then((value) => {
                                                            var UniversalID = ''
                                                            if (value.UniversalID!=undefined && value.UniversalID!=false){
                                                                UniversalID = value.UniversalID
                                                            }
                                                            else{
                                                                alert('Не удалось получить идентификатор банковской транзакции из заказа.')
                                                                return
                                                            }
                                                            order.set_kkm_UniversalIDRefund(UniversalID)
                                                            ReturnPaymentByPaymentCard(UrlServer,User,Password,InnKkm,Amount,NumDevice,UniversalID,self);
                                                        }).catch((err) => {
                                                            alert('Произошла ошибка при попытке получить информацию о возврате.' + err);
                                                            return;
                                                        });
                }
                else{
                    alert('Не выбран заказ для возврата.');
                }
          }
      };

   Registries.Component.extend(PaymentScreen, KKM_Return_Payment_By_Payment_Card);
   return KKM_Return_Payment_By_Payment_Card;
});

function ReturnPaymentByPaymentCard(UrlServer,User,Password,InnKkm,Amount,NumDevice,UniversalID,self) {
    console.log('ReturnPaymentByPaymentCard');
    LogJS('info','ReturnPaymentByPaymentCard')
    var IdCommandOnly = guid()
    console.log('guid платежа: ',IdCommandOnly);
    LogJS('warning','guid платежа: '+IdCommandOnly)
    ord.set_kkm_pay_return_kkm_guid(IdCommandOnly)
     var Data = {
        Command: "ReturnPaymentByPaymentCard",
        InnKkm: InnKkm,
        NumDevice: NumDevice,
        Amount: Amount,
        UniversalID: UniversalID,
        IdCommand: IdCommandOnly,
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommandReturn(UrlServer,User,Password,Data,self,ExecuteSuccessPayReturnOnly);
};

function ExecuteSuccessPayReturnOnly(Rezult, textStatus, jqXHR) {
            console.log('ExecuteSuccessPayReturnOnly');
            LogJS('info','ExecuteSuccessPayReturnOnly')
            console.log('Rezult: ',JSON.stringify(Rezult));
            LogJS('warning','Rezult: '+JSON.stringify(Rezult))
            console.log('Status: ',Rezult.Status);
            LogJS('warning','Status: '+Rezult.Status)
            var state = Rezult.Status;
            if (state == 1 || state == 4) { // значит команда еще выполняется или еще не запустилась
                alert('Терминал находится в режиме ожидания. Проверьте статус возврата платежа позже.');
            } else {
                if (Rezult.Status==0){
                    if (Rezult.Slip!=undefined){
                        console.log('Slip: ',Rezult.Slip);
                        LogJS('warning','Slip: '+Rezult.Slip)
                        //var test = " ИП Свистунова А.Н. \r\n 353560, Краснодарский край, \r\n Славянский р-н, г \r\n Славянск-на-Кубани, \r\n Красная/Дзержинского, -, - \r\nЧЕК: 0012 ОПЛАТА ПОКУПКИ\r\n15.11.23 16:54:31\r\nТЕРМИНАЛ: 92556988\r\nКАРТА: MIR W\r\n    ** 0494\r\nAID: A0000006581010 TSI: 4800\r\nTVR: 8080008000 CDA: ----\r\nСУММА (RUB) 41.00\r\n ОДОБРЕНО \r\nКОД ОТВЕТА: 000\r\nКОД АВТОРИЗАЦИИ: 4952NE\r\nССЫЛКА: 331959317247 KVR: ----\r\n================================\r\n\r"
                        //alert(test);
                        var res_short = Rezult.Slip.toLowerCase(); //test.toLowerCase()
                        console.log('res_short: ',res_short);
                        LogJS('warning','res_short: '+res_short)
                        if (res_short.indexOf('код ответа')>-1){
                            res_short = res_short.slice(res_short.indexOf('код ответа'))
                            res_short = res_short.slice(0,res_short.indexOf('\n'))
                            res_short = res_short.replace('код ответа','').replace(':','').trim()
                            if (res_short=='000'){
                                console.log('validateOrder start');
                                LogJS('info','validateOrder start')
                                //alert('УСПЕХ');
                                self.validateOrder(false)
                            }
                            else{
                                alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты.')
                                return;
                            }
                        }
                        else{
                            if (res_short.indexOf('одобрено')>-1){
                                console.log('validateOrder start');
                                LogJS('info','validateOrder start')
                                //alert('УСПЕХ');
                                self.validateOrder(false)
                            }
                            else{
                                alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                return;
                            }
                        }
                    }
                }
                else{
                    ord.set_kkm_pay_return_kkm_guid(null)
                    alert('Работа терминала завершилась с ошибкой. ' + Rezult.Error);
                }
            }
        };

function ExecuteCommandReturn(UrlServer,User,Password,
    Data,
    self,
    FunSuccess,
    FunError,
    timeout) {
    console.log('ExecuteCommandReturn');
    LogJS('info','ExecuteCommandReturn')
    if (FunSuccess === undefined) {
        FunSuccess = ExecuteSuccess;
    }
    if (timeout === undefined) {
        timeout = timeout_term * 60000;
    }
    try {
        if (KkmServer != undefined) {
            if (typeof (Data) == "string") Data = JSON.parse(Data);
            KkmServer.Execute(FunSuccess, Data);
            return;
        };
    } catch { };

    var JSon = JSON.stringify(Data);
    $.support.cors = true;
    var jqXHRvar = $.ajax({
        type: 'POST',
        async: true,
        timeout: timeout,
        url: UrlServer + ((UrlServer == "") ? window.location.protocol + "//" + window.location.host + "/" : "/") + 'Execute',
        crossDomain: true,
        dataType: 'json',
        contentType: 'application/json; charset=UTF-8',
        processData: false,
        data: JSon,
        headers: (User != "" || Password != "") ? { "Authorization": "Basic " + btoa(User + ":" + Password) } : "",
        success: FunSuccess,
        error: FunError
    });
        console.log('Ответ ККМ: ',jqXHRvar);
        LogJS('warning','Ответ ККМ: '+jqXHRvar)
}

function ExecuteSuccessPayReturn(Rezult, textStatus, jqXHR) {
            console.log('ExecuteSuccessPayReturn');
            LogJS('info','ExecuteSuccessPayReturn')
            console.log('Rezult: ',JSON.stringify(Rezult));
            LogJS('warning','Rezult: '+JSON.stringify(Rezult))
            console.log('Status: ',Rezult.Status);
            LogJS('warning','Status: '+Rezult.Status)
            if (Rezult.Status == 0) {
                MessageStatus = "Успешно";
            } else if (Rezult.Status == 1) {
                MessageStatus = "Выполняется";
            } else if (Rezult.Status == 2) {
                MessageStatus = "Ошибка!";
            } else if (Rezult.Status == 3) {
                MessageStatus = "Данные не найдены!";
            };
            MessageError = Rezult.Error;

            var MessageCheckNumber = Rezult.CheckNumber;
            var MessageSessionNumber = Rezult.SessionNumber;
            var MessageLineLength = Rezult.LineLength;
            var MessageAmount = Rezult.Amount;

            var state = Rezult.Status;
            if (state == 1 || state == 4) { // значит команда еще выполняется или еще не запустилась
                //Вывод данных что результат еще не выполнен
                CounGetRezult = CounGetRezult + 1;
                $("#MessageStatus").text("Выполняется: Запрос №:" + CounGetRezult);
                var Data = {
                    Command: "GetRezult",
                    IdCommand: IdCommand,
                };
                console.log('Data',JSON.stringify(Data));
                LogJS('warning','Data: '+JSON.stringify(Data))
                setTimeout(function () { ExecuteCommandSetRezultReturn(UrlServer,User,Password,Data,null,IdCommand, ExecuteSuccessSetRezultReturn, null, false) }, 1000);
            } else {

            if (Rezult.Status==0){
                if (Rezult.Slip!=undefined){
                    console.log('Slip: ',Rezult.Slip);
                    LogJS('warning','Slip: '+Rezult.Slip)
                    //var test = " ИП Свистунова А.Н. \r\n 353560, Краснодарский край, \r\n Славянский р-н, г \r\n Славянск-на-Кубани, \r\n Красная/Дзержинского, -, - \r\nЧЕК: 0012 ОПЛАТА ПОКУПКИ\r\n15.11.23 16:54:31\r\nТЕРМИНАЛ: 92556988\r\nКАРТА: MIR W\r\n    ** 0494\r\nAID: A0000006581010 TSI: 4800\r\nTVR: 8080008000 CDA: ----\r\nСУММА (RUB) 41.00\r\n ОДОБРЕНО \r\nКОД ОТВЕТА: 000\r\nКОД АВТОРИЗАЦИИ: 4952NE\r\nССЫЛКА: 331959317247 KVR: ----\r\n================================\r\n\r"
                    //alert(test);
                    var res_short = Rezult.Slip.toLowerCase(); //test.toLowerCase()
                    console.log('res_short: ',res_short);
                    LogJS('warning','res_short: '+res_short)
                    if (res_short.indexOf('код ответа')>-1){
                        res_short = res_short.slice(res_short.indexOf('код ответа'))
                        res_short = res_short.slice(0,res_short.indexOf('\n'))
                        res_short = res_short.replace('код ответа','').replace(':','').trim()
                        if (res_short=='000'){
                            self.validateOrder(false)
                        }
                        else{
                            alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты.')
                            return;
                        }
                    }
                    else{
                            if (res_short.indexOf('одобрено')>-1){
                                    self.validateOrder(false)
                                }
                                else{
                                    alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                    return;
                                }
                        }
                }
            }
            if (MessageError !="" && MessageError!=undefined) {
                alert(MessageStatus+"\nСообщение об ошибке:"+MessageError);
                return;
            }//{mes=mes+"\n Сообщение об ошибке:"+MessageError}
            }
        };

function ExecuteSuccessSetRezultReturn(Rezult, textStatus, jqX) {
            console.log('ExecuteSuccessSetRezultReturn');
            LogJS('info','ExecuteSuccessSetRezultReturn')
            console.log('Rezult: ',JSON.stringify(Rezult));
            LogJS('warning','Rezult: '+JSON.stringify(Rezult))
            console.log('Status: ',Rezult.Status);
            LogJS('warning','Status: '+Rezult.Status)
            var state = Rezult.Status;
            if (state == 1 || state == 4) {
                CounGetRezult = CounGetRezult + 1;
                $("#MessageStatus").text("Выполняется: Запрос №:" + CounGetRezult);
                //alert("Выполняется: Запрос №:" + CounGetRezult)
                var Data = {
                    Command: "GetRezult",
                    IdCommand: IdCommand,
                };
                console.log('Data',JSON.stringify(Data));
                LogJS('warning','Data: '+JSON.stringify(Data))
                setTimeout(function () { ExecuteCommandSetRezultReturn(UrlServer,User,Password,Data,null,IdCommand, ExecuteSuccessSetRezultReturn, null, false) }, 1000);
            } else { // Rezult.Status <> 1 - значит команда уже выполнена
                // Вывод результата выполнения команды
                //alert('RezultNew:\n' + JSON.stringify(Rezult))
                //alert('status:\n' + Rezult.Status)
                if (state==0){
                    if (Rezult.Rezult.UniversalID){
                        ord.set_kkm_UniversalID(Rezult.Rezult.UniversalID)
                    }
                    //alert('Slip:\n' + Rezult.Rezult.Slip)
                    if (Rezult.Rezult.Slip!=undefined){
                        console.log('Slip: ',Rezult.Rezult.Slip);
                        LogJS('warning','Slip: '+Rezult.Rezult.Slip)
                        //var test = " ИП Свистунова А.Н. \r\n 353560, Краснодарский край, \r\n Славянский р-н, г \r\n Славянск-на-Кубани, \r\n Красная/Дзержинского, -, - \r\nЧЕК: 0012 ОПЛАТА ПОКУПКИ\r\n15.11.23 16:54:31\r\nТЕРМИНАЛ: 92556988\r\nКАРТА: MIR W\r\n    ** 0494\r\nAID: A0000006581010 TSI: 4800\r\nTVR: 8080008000 CDA: ----\r\nСУММА (RUB) 41.00\r\n ОДОБРЕНО \r\nКОД ОТВЕТА: 000\r\nКОД АВТОРИЗАЦИИ: 4952NE\r\nССЫЛКА: 331959317247 KVR: ----\r\n================================\r\n\r"
                        var res_short = Rezult.Rezult.Slip.toLowerCase();
                        console.log('res_short: ',res_short);
                        LogJS('warning','res_short: '+res_short)
                        if (res_short.indexOf('код ответа')>-1){
                            res_short = res_short.slice(res_short.indexOf('код ответа'))
                            res_short = res_short.slice(0,res_short.indexOf('\n'))
                            res_short = res_short.replace('код ответа','').replace(':','').trim()
                            if (res_short=='000'){
                                self.validateOrder(false)
                            }
                            else{
                                if (res_short.indexOf('одобрено')>-1){
                                    self.validateOrder(false)
                                }
                                else{
                                    alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                    return;
                                }
                            }
                        }
                        else{
                                if (res_short.indexOf('одобрено')>-1){
                                    self.validateOrder(false)
                                }
                                else{
                                    alert('Оплата не завершена. Попробуйте еще раз или измените тип оплаты')
                                    return;
                                }
                            }
                    }
                    else{
                        alert('Не вернулся слип чек')
                     }
                }
            }
        }


function ExecuteCommandSetRezultReturn(UrlServer,User,Password,
    Data,
    currentOrder,
    IdCommand,
    FunSuccess,
    FunError,
    timeout) {
    console.log('ExecuteCommandSetRezultReturn');
    LogJS('info','ExecuteCommandSetRezultReturn')
    if (FunSuccess === undefined) {
        FunSuccess = ExecuteSuccess;
    }
    if (timeout === undefined) {
        timeout = timeout_term * 60000;
    }
    try {
        if (KkmServer != undefined) {
            if (typeof (Data) == "string") Data = JSON.parse(Data);
            KkmServer.Execute(FunSuccess, Data);
            return;
        };
    } catch { };
    var JSon = JSON.stringify(Data);
    $.support.cors = true;
    var jqXHRvar = $.ajax({
        type: 'POST',
        async: true,
        timeout: timeout,
        url: UrlServer + ((UrlServer == "") ? window.location.protocol + "//" + window.location.host + "/" : "/") + 'Execute',
        crossDomain: true,
        dataType: 'json',
        contentType: 'application/json; charset=UTF-8',
        processData: false,
        data: JSon,
        headers: (User != "" || Password != "") ? { "Authorization": "Basic " + btoa(User + ":" + Password) } : "",
        success: FunSuccess,
        error: FunError
    });
        console.log('Ответ ККМ: ',jqXHRvar);
        LogJS('warning','Ответ ККМ: '+jqXHRvar)
}