var glSelf;

odoo.define('kkm_server.ClosePosPopupTerminalReport', function(require) {
    "use strict";

    const { _t } = require('web.core');
    const ClosePosPopup = require('point_of_sale.ClosePosPopup');
    const Registries = require('point_of_sale.Registries');
    const NumberBuffer = require('point_of_sale.NumberBuffer');

    const PosKKMClosePosPopupTerminalReport = (ClosePosPopup) => class extends ClosePosPopup {

        async TerminalReport_click() {
            var self = this;
            glSelf = this;
            console.log('TerminalReport_click');
            LogJS('info','TerminalReport_click')
            var UrlServer = this.env.pos.config.UrlServer;
            if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
            var User = this.env.pos.config.User;
            var Password = this.env.pos.config.Password;
            var NumDevice = 0;
            if (this.env.pos.config.NumDevice_term!=undefined && this.env.pos.config.NumDevice_term!=false){
                NumDevice=this.env.pos.config.NumDevice_term
            }
            var InnKkm = "";
            if (this.env.pos.config.InnKkm_term!=undefined && this.env.pos.config.InnKkm_term!=false){
                InnKkm=this.env.pos.config.InnKkm_term
            }
            var Detailed = this.env.pos.config.Detailed
            var Data = {
                Command: "TerminalReport",
                InnKkm: InnKkm,
                NumDevice: NumDevice,
                Detailed: Detailed,
                IdCommand: guid()
            };
            console.log('Data',JSON.stringify(Data));
            LogJS('warning','Data: '+JSON.stringify(Data))
            ExecuteCommand(UrlServer,User,Password,Data);
        }

    };

    Registries.Component.extend(ClosePosPopup, PosKKMClosePosPopupTerminalReport);

    return PosKKMClosePosPopupTerminalReport;
});