var mes="";
var glSelf;
var CashierName;
var CashierVATIN;

odoo.define('kkm_server.open_kkm', function(require) {
'use strict';
  const { Gui } = require('point_of_sale.Gui');
  const PosComponent = require('point_of_sale.PosComponent');
  const { identifyError } = require('point_of_sale.utils');
  const ProductScreen = require('point_of_sale.ProductScreen');
  const { useListener } = require("@web/core/utils/hooks");
  const Registries = require('point_of_sale.Registries');
  const PaymentScreen = require('point_of_sale.PaymentScreen');

class KKM_Open extends PosComponent {
      setup() {
          super.setup();
          useListener('click', this.onClick);
      }

     async onClick() {
        glSelf = this;
        var self = this;
        console.log('open_kkm');
        LogJSOpen('info','open_kkm');
        var UrlServer = this.env.pos.config.UrlServer;
        if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
        var User = this.env.pos.config.User;
        var Password = this.env.pos.config.Password;
        var NumDevice = 0;
        if (this.env.pos.config.NumDevice_fiscal!=undefined && this.env.pos.config.NumDevice_fiscal!=false){
                NumDevice=this.env.pos.config.NumDevice_fiscal
            }
        var InnKkm = '';
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                InnKkm=this.env.pos.config.InnKkm_fiscal
            }
        var order = this.env.pos.get_order();
        var NotPrint = this.env.pos.config.NotPrint;
        console.log('order',order);
        LogJSOpen('info','order: '+order)
        var res = this.env.services.rpc({
            route: '/cashier/info',
            params: {
                cashier_id: this.env.pos.get_cashier_user_id(),
            },
        }, { shadow: true }).then((value) => { CashierName = value['name'];
                                            CashierVATIN =  value['inn'];
                                            OpenShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm);
                                            }).catch((err) => {
                                            CashierName = this.env.pos.config.CashierName[1];
                                            CashierVATIN = this.env.pos.config.CashierVATIN;
                                            OpenShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm);
                                            });


        }
  }

KKM_Open.template = 'KKM_Open';
  ProductScreen.addControlButton({
      component: KKM_Open,
      condition: function () {
            var has_enabled = false;
            if (this.env.pos.config.enable_kkm_server) {
                has_enabled = true;
            }
            return has_enabled;
        },
      position: ['before', 'OrderlineCustomerNoteButton'],
  });

  Registries.Component.add(KKM_Open);

  return {
    KKM_Open,
    Gui: Gui,
  };
});

function LogJSOpen(Level, Message) {
    glSelf.env.services.rpc({
        route: '/loggerjs/message',
        params: {
            Level: Level,
            Message: Message,
        },
    }, { shadow: true }).then((value) => { console.log(value);
                                        }).catch((err) => {console.log(err);
                                        });
}



